Unit CalcMov;

{
                    Faz o calculo de todo o movimento,
               armazenando na fila de movimento,  tem
               tambem as funcoes de criacao,  destrui-
               cao e insercao da fila. Calcula a tabe-
               la de senos e  cossenos  e  possui uma
               funcao para calculo de arco-cosseno.
}

Interface

Uses Crt, Dos, Graph;


Const
      LARGURA = 14; { Largura em pixeis da esfera }
      ALTURA  = 14; { Altura em pixeis da esfera }
      INICIO = 10;   { Coluna de inicio da guia }
      MEIO = 130;   { Coluna do meio da guia }
      FIM = 250;    { Coluna do fim da guia }
      NIVELZERO = 178; { Linha em que se encontra a base da guia }
      INCR = 3; {incremento de tres em tres graus}
Type

   Str5 = String[5];

   ptovet = array [1..9] of word;{Coordenadas dos vetores das forcas}

   pt_movimento = ^movimento;
   movimento = record
                 x,y : word;  { Coordenadas da esfera na tela.        }
                 V,           { Velocidade da esfera.                 }
                 At,An,Ar,    { Aceleracoes, tangencial, normal, e    }
                              { resultante, respectivamente, atuantes }
                              { na esfera.                            }
                 Ft,Fn,Fcf,Fr,{ Forcas, tangencial, normal,centrifuga }
                              { e resultante,respectivamente,atuantes }
                              { na esfera.                            }
                 Alfa,        { Angulo entre as forcas tangencial e   }
                              { resultante                            }
                 Teta :Real;{ Angulo da guia, em que esta a esfera  }
                 Ptgrafx,
                 Ptgrafy: ptovet;{Coordenadas x e y dos vetores das forcas}
                 acdes,       { Variacao da aceleracao de um nodo para}
                              { outro do movimento                    }
                 vedes: Word; { Variacao da velocidade, idem anterior }
                 Dir : Boolean;{ Direcao do vetor acereacao resultante}
                               { se true esta correta, caso contrario }
                               { esta invertida                       }
                 prox : pt_movimento;{ ponteiro para o proximo nodo   }
               End;
   cabecalho   = record
                  V0,        { Velocidade inicial da esfera           }
                  Amax,      { Aceleracao maxima alcalcada pela esfera}
                  Fmax,      { Forca maxima atuante na esfera         }
                  R, G, M   : real; { Raio da guia em metros,gravidade}
                             { local, e massa da esfera               }
                  inicio, fim : pt_movimento;{ Ponteiros para o inicio}
                             { e fim da lista do movimento            }
                  raio, xc, yc: Integer;{ Raio da guia em pixeis,coor-}
                             { denadas do centro da guia              }
                 End;
   pt_cabecalho = ^cabecalho;


Function AsctoReal (Vetor: Str5): Real;

Procedure Carrega_Tabela ;

Function Inicializa_Fila(cb : pt_cabecalho): pt_cabecalho;

Procedure Destroe_Fila(Var cb : pt_cabecalho);

Procedure Calcula_Movimento (Var cb: pt_cabecalho);

Procedure Avaliacao_Inicial (Var cb : pt_cabecalho);


Var
  Seno, Coss : Array [1..120] of real;{120 = 360 div INCR}

Implementation

 {********************************************************************
  * Recebe um vetor string de cinco caracteres e converte e retorna o*
  * valor em real, retorna zero caso ocorra erro.                    *
  ********************************************************************}

Function AsctoReal (Vetor: Str5): Real;

 Var
  Cont:Byte;
  Peso,
  Result: Real;

 Begin
  Result:=0.0;
  Peso:=1;
  If (Pos('.',Vetor) = 0) Then
   Begin
    For Cont:=Length (Vetor) downto 1 do
     Begin
      Result:= Result + ((Ord (Vetor[Cont]) - 48) * Peso);
      Peso:=Peso*10;
     End;
   End
  Else
   Begin
    Peso:=0.1;
    For Cont:=Pos ('.',Vetor) +1 to Length (Vetor) do
     Begin
      Result:=Result + ((Ord (Vetor[Cont]) - 48) * Peso);
      Peso:=Peso*0.1;
     End;
    Peso:=1;
    For Cont:=Pos ('.',Vetor) -1 Downto 1 do
     Begin
      Result:=Result + ((Ord (Vetor[Cont]) - 48) * Peso);
      Peso:=Peso*10;
     End;
   End;
  AsctoReal:=Result;
 End;



{*******************************************************************}
{* Cria a tabela de senos e cossenos num intervalo especificado por*}
{* INCR em dois vetores                                            *}
{*******************************************************************}

Procedure Carrega_Tabela ;
Var A , IncrPi : Real;
    I, FimLoop : Byte;
Begin
  A := 0.0;
  FimLoop := 360 div INCR;
  IncrPi := Pi/(FimLoop div 2);
  For I := 1 to FimLoop do
    Begin
     Coss[I] := Cos (A);
     Seno[I] := Sin (A);
     A := A + IncrPi;
    End
End;

 {********************************************************************
  * Retorna o arco-cosseno de um valor dado usando busca binaria na  *
  * tabela de senos e cossenos para obte-lo.                         *
  ********************************************************************}

Function ArcCos (Valor: Real):Integer;

Var

 Inicio,
 Fim,
 Angulo: Integer;

 Achou: Boolean;

Begin
 Inicio:=60;
 Fim:=120;
 Achou:=False;
 If Valor > Coss[120] Then
   ArcCos:=120
 Else
 If Valor < Coss [60] Then
  ArcCos:= 60
 Else
  Begin
   While (Not Achou) and (Fim > Inicio) do
    Begin
     Angulo:=(Inicio + Fim) Div 2;
     If (Coss[Angulo] < Valor) And (Coss[Angulo+1] > Valor) Then
      Achou:=True;
     If Coss[Angulo] > Valor Then
      Fim:=Angulo
     Else
      If Coss[Angulo] < Valor Then
       Inicio:=Angulo;
    End;
   ArcCos:=Angulo;
  End;
End;




{*******************************************************************}
{* Inicializa a fila de nodos, alocando o nodo cabeca e o primeiro *}
{* nodo, ja fazendo o cabeca apontar para este                     *}
{*******************************************************************}

Function Inicializa_Fila(cb : pt_cabecalho): pt_cabecalho;
Var
  p : pt_movimento;
Begin
  New(cb);
  New(p);
  FillChar(cb^, Sizeof(cb^), 0);
  FillChar(p^, Sizeof(p^), 0);
  cb^.inicio := p;
  cb^.fim := p;
  Inicializa_Fila:=cb;
End;

{*******************************************************************}
{* Recebe um ponteiro para o nodo cabeca da fila, cria um novo nodo*}
{* inicializa-o e devolove um ponteiro para este nodo recem criado *}
{*******************************************************************}

Function Proximo_Nodo(Var cb : pt_cabecalho): pt_movimento;
Var p : pt_movimento;
Begin
  New(cb^.fim^.prox);
  cb^.fim := cb^.fim^.prox;
  FillChar(cb^.fim^, Sizeof(cb^.fim^), 0);
  Proximo_Nodo := cb^.fim;
End;

{*******************************************************************}
{* Destroe Fila recebe um apontador para o nodo cabeca da fila e   *}
{* desaloca toda a fila, inclusive o proprio nodo cabeca           *}
{*******************************************************************}

Procedure Destroe_Fila(Var cb : pt_cabecalho);
Var p : pt_movimento;

Begin
  p := cb^.inicio;
  While p <> nil do
   Begin
     cb^.inicio := p^.prox;
     Dispose(p);
     p := cb^.inicio;
   End;
  cb^.fim := nil;
  Dispose(cb);
End;

{*******************************************************************}
{* Avaliacao_Inicial recebe um apontador para o nodo cabeca ja com *}
{* com os dados iniciais do movimento no cabecalho, procedendo uma *}
{* pre-avaliacao do comportamento da esfera na guia para estimar   *}
{* quais serao os valores maximos e minimos das variaveis atuantes *}
{* e assim poder estimar os limites dos graficos da aceleracao,    *}
{* velocidade e forcas                                             *}
{*******************************************************************}

Procedure Avaliacao_Inicial (Var cb : pt_cabecalho);
Var
  An, Fn, Fcf : real;
Begin
   An := (cb^.V0 * cb^.V0)/cb^.R;
   Fn := cb^.M * An;
   Fcf := Fn + cb^.M*cb^.G;
   cb^.Amax:= Fcf/cb^.M;
   cb^.Fmax := cb^.M * cb^.Amax;
End;


{*******************************************************************}
{* Movimento_Uniforme recebe um ponteiro para o nodo cabeca da fila*}
{* e conduz a partir da posicao corrente , a esfera em movimento   *}
{* uniforme ate pontos dependentes da situacao inicial ,a saber :  *}
{*  1) caso a esfera esteja no inicio do movimento sera conduzida  *}
{*     ate o meio da guia,ou seja, ate a base do looping;          *}
{*  2) caso a esfera esteja no meio da guia sera conduzida ate o   *}
{*     seu final                                                   *}
{*******************************************************************}

Procedure Movimento_Uniforme(Var cb : pt_cabecalho);

Var
  xcorr, ycorr, Incrx: Integer;
  m : pt_movimento;

Begin
  Incrx := 2;
  ycorr := cb^.fim^.y;
  If cb^.fim^.x = INICIO then
    {conduz ate o meio}
   Repeat
     xcorr := cb^.fim^.x;
     m := Proximo_Nodo(cb);
     m^.V := cb^.V0;
     m^.x := xcorr + Incrx;
     m^.y := ycorr;
   Until (m^.x >= MEIO - LARGURA div 2)
  else
    {conduz ate o final}
   Repeat
     xcorr := cb^.fim^.x;
     m := Proximo_Nodo(cb);
     m^.V := cb^.V0;
     m^.x := xcorr + Incrx;
     m^.y := ycorr;
   Until (m^.x >= FIM + LARGURA div 2);
End;

{*******************************************************************}
{* Retorno recebe um ponteiro para o nodo cabeca da fila, e chamado*}
{* quando a esfera nao conseguira realizar o looping e retornara   *}
{* para o ponto inicial, o procedimento conduz a esfera de sua     *}
{* posicao atual, obtida pelo angulo, ate o inicio da guia         *}
{*******************************************************************}

Procedure Retorno(Var cb : pt_cabecalho);

Var V0_quad,
    V,
    Dois_g,
    Temp,
    H : Real;
    IniLoop, Beta, xcorr, ycorr, Incrx : Integer;

    m : pt_movimento;
Begin
  Incrx := 2;
  V0_quad := cb^.V0 * cb^.V0;
  IniLoop := 0;
  Dois_g := cb^.G + cb^.G;
  { Tranforma o valor de Teta em radianos para em graus no intervalo de Beta}
  Beta := Round ((cb^.fim^.Teta*180)/(Pi*INCR))-1;
  If Beta <= 0 then Beta := 1;
  Repeat
    Begin
      m := Proximo_Nodo(cb);
      H := cb^.R*(1 - Coss[Beta]);
      Temp := V0_quad - Dois_g * H;
      If (Temp) > 0 then
          m^.V := Sqrt (Temp);
      m^.At := cb^.G * Seno[Beta];
      m^.Ft := cb^.M * m^.At;
      m^.An := (m^.V * m^.V)/cb^.R;
      m^.Fn := cb^.M * m^.An;
      m^.Fcf := m^.Fn + cb^.M*cb^.G* Coss[Beta];
      m^.Ar := Sqrt ( m^.At * m^.At + m^.An * m^.An);
      m^.Dir := true;
      m^.Fr := cb^.M * m^.Ar;
      If m^.Fcf <>  0.0 then { Evita divisao por zero}
        m^.Alfa := ArcTan(Abs(m^.Ft/m^.Fcf));
      m^.Teta := Pi*Beta*INCR/180; { Transforma o valor de Beta para radianos}
      { Coordenadas x e y na tela da esfera neste ponto do movimento}
      m^.x := Round(cb^.xc + (cb^.raio -LARGURA/2) * Seno[Beta]*6/5 -LARGURA/2 );
      m^.y := Round(cb^.yc + (cb^.raio -LARGURA/2) * Coss[Beta] - ALTURA/2);
      Dec(Beta);
    End
  Until (Beta = IniLoop);
  ycorr := m^.y;
  Repeat
    {conduz a esfera ate o inicio}
    xcorr := m^.x;
    m := Proximo_Nodo(cb);
    m^.V := cb^.V0;
    m^.x := xcorr - Incrx;
    m^.y := ycorr;
  Until (m^.x <= INICIO);

End;


{*******************************************************************}
{* Queda_Parabolica recebe um ponteiro para o nodo cabeca da fila, *}
{* e chamado quando a tracao se tornou zero e a esfera cai por uma *}
{* parabola, tem por funcao conduzir a esfera neste  lancamento    *}
{* parabolico a partir do angulo corrente do looping ate que a     *}
{* esfera retome o contato com a guia, devolve no nodo o angulo em *}
{* que a esfera tocou a guia.                                      *}
{*******************************************************************}

Procedure Queda_Parabolica(Var cb : pt_cabecalho);

Var
  P,      { Peso da esfera }
  xt,yt,  { Coord. da tela }
  xr, yr, { Coord. do mundo}
  h,    { Altura em que se encontra a esfera }
  d,    { Distancia da esfera do centro da guia}
  Gama, { Angulo inicial de lancamento }
  Vx,   { Velocidade em relacao ao eixo x }
  V0y,  { Velocidade inicial em relacao ao eixo y }
  Vy,   { Velocidade atual em relacao ao eixo y }
  Vyanterior, { Velocidade no nodo anterior em relacao ao eixo y }
  t,    { Tempo }
  Incrt, {Incremento do tempo }
  Aux, { Auxiliar para calculo do angulo de retorno a guia. }
  Aux1, Aux2 : Real;  { Auxiliares para o calculo de "d" }
  m : pt_movimento; { Ponteiro ao nodo corrente. }
  Beta : integer;   { Indice dos vetores de senos e cossenos. }
  PodeSair : boolean; { Indica se a esfera ja esta em situacao de sair da
                        queda parabolica. }
  xant , yant,        { Coordenadas da esfera na tela no nodo anterior. }
  xatu, yatu : integer; { Coord. da esfera na tela no nodo atual. }


Begin
  { Inicializacao das variaveis locais }
  PodeSair := false;
  Incrt := (cb^.R/cb^.V0)*0.08;   { Valor obtido atravez de experiencia. }
  P := cb^.M * cb^.G;
  xant := cb^.fim^.x;
  yant := cb^.fim^.y;
  xt := xant;
  yt := yant;
  Gama := Pi - cb^.fim^.Teta; { Angulo de lancamento em relacao a base. }
  Vx := cb^.fim^.V * cos(Gama);
  V0y := cb^.fim^.V * sin(Gama);
  Beta := Round ((cb^.fim^.Teta*180)/(Pi*INCR)) + 1;
  h := cb^.R*(1-Coss[Beta]);
  t := Incrt;
  Vyanterior := V0y - cb^.G*t;
  Repeat
    yr := V0y*t - (cb^.G*t*t)/2;
    Vy := V0y - cb^.G*t;
    If Abs(Vy) > Abs(Vyanterior) then PodeSair := true;  { Se a esfera ja
                                    esta caindo, aceleracao positiva. }
    Vyanterior := Vy;
    xr := Vx*t;
    { cb^.Raio / cb^.R , Relacao tela / mundo. }
    yatu :=  Round(yt - yr * cb^.raio/cb^.R);  { Calculo de y no nodo atual }
    xatu :=  Round(xt - xr * cb^.raio/cb^.R*6/5);{ Calculo de x no nodo
                            atual, multiplicado pela distorcao de video.}
    t := t + Incrt;
    If (xatu <> xant) or (yatu <> yant) then
      Begin { E um novo ponto. }
        { Aloca e calcula valores no nodo. }
        m := Proximo_Nodo(cb);
        m^.y := yatu;
        m^.x := xatu;
        m^.Fcf  := P;
        m^.Ar := cb^.G;
        m^.Dir := true;
        m^.Fr := P; { Peso e a unica forca atuante. }
        m^.Teta := 2*Pi; {Peso e sempre para baixo. }
        m^.V := Sqrt(Vx*Vx + Vy*Vy);
        { LARGURA e ALTURA sao introduzidos para desfazer a distorcao
          causada pelo calculo feito sempre com o ponto esquerdo superior. }
        If (m^.x > cb^.xc) and (m^.y> cb^.yc) then
          Begin { Esta no primeito quadrante }
           Aux1 := ((m^.x+LARGURA )-cb^.xc)*5/6*((m^.x + LARGURA  )-cb^.xc)*5/6;
           Aux2 := ((m^.y + ALTURA )-cb^.yc)*((m^.y + ALTURA )-cb^.yc)
          End
        else
         If (m^.x < cb^.xc) and (m^.y > cb^.yc) then
           Begin { Esta no terceiro quadrante }
             Aux1 := ((m^.x)-cb^.xc)*5/6*((m^.x)-cb^.xc)*5/6;
             Aux2 := ((m^.y + ALTURA )-cb^.yc)*((m^.y + ALTURA )-cb^.yc)
           End
         else
           Begin { Esta no quarto quadrante. }
             Aux1 := ((m^.x  )-cb^.xc)*5/6*((m^.x  )-cb^.xc)*5/6;
             Aux2 := ((m^.y  )-cb^.yc)*((m^.y  )-cb^.yc);
           End;
        d := Sqrt( Abs(Aux1 + Aux2 ) ); {<distancia entre x,y e o centro>}
        If (m^.x > cb^.xc) and (m^.y < cb^.yc) and (d >= cb^.raio) then
         PodeSair := false; { Se esta no segundo quadrante nao pode sair. }
      End;
    xant := xatu;
    yant := yatu;
 { Ate a distancia entre a esfera e o centro da guia ser maior ou igual
   ao raio e obedecer as condicoes obtidas por experiencia. }
 Until (d >= cb^.raio) and (PodeSair);
 { Calculo do angulo em que a esfera tocou a guia. }
 If (m^.x < cb^.xc) and (m^.y < cb^.yc) then
   Begin { Terceiro quadrante. }
     Aux1:=  ((m^.x*5/6+LARGURA-cb^.xc*5/6)*(MEIO-cb^.xc)*5/6+(m^.y-cb^.yc)*(NIVELZERO-cb^.yc))/(cb^.raio*cb^.raio);
     m^.Teta := ArcCos(Aux1)*pi/60
   End
 Else
 If m^.x > cb^.xc Then
  Begin { Segundo quadrante }
    Aux1:= ((m^.x*5/6+LARGURA-cb^.xc*5/6)*(MEIO-cb^.xc)*5/6+(m^.y+ALTURA-cb^.yc)*(NIVELZERO-cb^.yc))/(cb^.raio*cb^.raio);
    m^.Teta := 2*pi - ArcCos(Aux1)*pi/60
  End
 Else
  Begin { Quarto quadrante. }
    Aux1:= ((m^.x*5/6+LARGURA-cb^.xc*5/6)*(MEIO-cb^.xc)*5/6+(m^.y+ALTURA-cb^.yc)*(NIVELZERO-cb^.yc))/(cb^.raio*cb^.raio);
    m^.Teta := ArcCos(Aux1)*pi/60
  End;
End;


{*******************************************************************}
{* Looping_Total recebe um ponteiro para o nodo cabeca da fila, e  *}
{* chamado para conduzir a esfera a partir de um ponto qualquer no *}
{* looping, ate que a velocidade ou tracao sejam nulas, quando     *}
{* significa que a velocidade inicial foi insuficiente, ou ate que *}
{* a esfera tenha terminado de realizar o looping                  *}
{*******************************************************************}

Procedure Looping_Total (Var cb : pt_cabecalho);

Var V0_quad, { Auxiliar para calculo, velocidade inicial ao quadrado }
    Dois_g, { Auxiliar p/ calculo, (Duas vezes a gravidade ) }
    Temp,  { Auxiliar p/ calc. Velocidade no nodo atual. }
    H : Real; { Altura da esfera na guia }
    FimLoop, { Numero de interacoes executadas dentro do looping }
    Beta : Integer; { Indice da tabela de senos e cossenos. }

    m : pt_movimento;
Begin
  { Inicializacao das variaveis locais }
  V0_quad := cb^.V0 * cb^.V0;
  FimLoop := 360 div INCR;
  Dois_g := cb^.G + cb^.G;
  Beta := Round ((cb^.fim^.Teta*180)/(Pi*INCR)) + 2;
  { Incrementos de Beta obtidos por experiencia }
  If Beta > 117 then Beta := 120;
  Repeat { Alocacao e calculo dos valores no nodo. }
      m := Proximo_Nodo(cb);
      H := cb^.R*(1 - Coss[Beta]);
      Temp := V0_quad - Dois_g * H;
      If (Temp) > 0 then
          m^.V := Sqrt (Temp);
      m^.At := cb^.G * Seno[Beta];
      m^.Ft := cb^.M * m^.At;
      If m^.At < 0.0 Then m^.Dir := true;
      m^.An := (m^.V * m^.V)/cb^.R;
      m^.Fn := cb^.M * m^.An;
      m^.Fcf := m^.Fn + cb^.M*cb^.G* Coss[Beta];
      m^.Ar := Sqrt ( m^.At * m^.At + m^.An * m^.An);
      m^.Fr := cb^.M * m^.Ar;
      If m^.Fcf <>  0.0 then
        m^.Alfa := ArcTan(m^.Ft/m^.Fcf);
      m^.Teta := Pi*Beta*INCR/180;  {Calcula o valor em radianos}
      { Calculo das coords.da esfera na tela. }
      m^.x := Round(cb^.xc + (cb^.raio -LARGURA/2) * Seno[Beta]*6/5 -LARGURA/2 );
      m^.y := Round(cb^.yc + (cb^.raio -LARGURA/2) * Coss[Beta] - ALTURA/2);
      Inc(Beta);
      If Beta > 60 then m^.Fcf := Abs(m^.Fcf);
  { Ate a forca centrifuga ou velocidade nula, ou fim do looping }
  Until (m^.Fcf < 0.0) or (m^.V <= 0.0) or (Beta >= FimLoop);
End;



 Procedure Calculos_Graficos (cb: pt_cabecalho);

 Const

  MAX_BARRA_ACEL = 24; {Comprimento maximo da barra de aceleracao.}
  MAX_BARRA_VEL  = 52; {Comprimento maximo da barra de velocidade.}

  RMAX = 28; {Comprimento maximo das hastes dos vetores.}
  RFMAX = 5; {Comprimento maximo das pontas dos vetores.}

  X = 285;  {Coordenadas do canto superior esquerdo do grafico.}
  Y = 127;

  DES = 45; {Deslocamento das pontas em relacao a haste de 135 graus.}

  CORA = 1.909859317e1;
           {Correcao aritmetico de radianos para indice do vetor}

 Var

  m: pt_movimento; {Ponteiro ao nodo corrente.}

  R,        {Comprimento da haste.}
  RF: Real; {Comprimento da ponta da haste.}

  Ang1,
  Ang2: Integer;  {Indices dos vetores de senos e cossenos.}

 Begin
  m:=cb^.inicio;
  Repeat
    m^.acdes:=Round(m^.Ar * MAX_BARRA_ACEL / cb^.Amax);  {Calculo do tamanho
                                                     da barra de aceleracao.}
    m^.vedes:=Round(Abs (m^.V) * MAX_BARRA_VEL / cb^.V0);{Calculo do tamanho
                                                     da barra de velocidade.}
    {Calculo das coordenadas do vetor da forca centrifuga.}
    R:=m^.Fcf*RMAX/cb^.Fmax;   {Calculo do tamanho da haste.}
    RF:=m^.Fcf*RFMAX/cb^.Fmax; {Calculo do tamanho da ponta da haste.}
    Ang1:=Round(CORA*m^.Teta);
    m^.Ptgrafx[1]:=Round (X+R*Seno[Ang1]);
    m^.Ptgrafy[1]:=Round (Y+R*Coss[Ang1]);
    Ang2:=Ang1-DES;
    Ang1:=(Ang1+DES) mod 121;
    If Ang1 = 0 Then
     Ang1:=1;
    If Ang2 <= 0 Then
     Ang2:=120+Ang2;
    {Ang2:=Abs(Ang2 mod 120 +1);}
    {Calculo das coordenadas das duas pontas do vetor da forca centrifuga.}
    m^.Ptgrafx[2]:=Round (m^.Ptgrafx[1]+RF*Seno[Ang1]);
    m^.Ptgrafy[2]:=Round (m^.Ptgrafy[1]+RF*Coss[Ang1]);
    m^.Ptgrafx[3]:=Round (m^.Ptgrafx[1]+RF*Seno[Ang2]);
    m^.Ptgrafy[3]:=Round (m^.Ptgrafy[1]+RF*Coss[Ang2]);
    {Calculo das coordenadas da forca tangencial.}
    R:=m^.Ft*RMAX/cb^.Fmax;      {Tamanho da haste}
    RF:=m^.Ft*RFMAX/cb^.Fmax;    {Tam. da ponta.}
    Ang1:=Round(CORA*(m^.Teta + Pi/2)) mod 120 + 1;
    m^.Ptgrafx[4]:=Round (X+R*Seno[Ang1]);
    m^.Ptgrafy[4]:=Round (Y+R*Coss[Ang1]);
   Ang2:=Ang1-DES;
    Ang1:=(Ang1+DES) mod 121;
    If Ang1 = 0 Then
     Ang1:=1;
    If Ang2 <= 0 Then
     Ang2:=120+Ang2;
{    Ang2:=Ang1-DES;
    If Ang2 < 0 Then
      Ang2:=120+Ang2;
    Ang1:=(Ang1+DES) mod 120 +1;
    Ang2:=Abs(Ang2 mod 120 +1);
 }   m^.Ptgrafx[5]:=Round (m^.Ptgrafx[4]+RF*Seno[Ang1]);
    m^.Ptgrafy[5]:=Round (m^.Ptgrafy[4]+RF*Coss[Ang1]);
    m^.Ptgrafx[6]:=Round (m^.Ptgrafx[4]+RF*Seno[Ang2]);
    m^.Ptgrafy[6]:=Round (m^.Ptgrafy[4]+RF*Coss[Ang2]);
    {Calculo das coordenadas da forca resultante.}
    R:=m^.Fr*RMAX/cb^.Fmax;   {Tam. da haste}
    RF:=m^.Fr*RFMAX/cb^.Fmax; {Tam. da ponta}
    If m^.Alfa < 0 Then
      Ang1:=Round (CORA * (m^.Teta + (2*Pi + m^.Alfa))) mod 121
     Else
      Ang1:=Round (CORA * (m^.Teta + m^.Alfa)) mod 121;
    m^.Ptgrafx[7]:=Round (X+R*Seno[Ang1]);
    m^.Ptgrafy[7]:=Round (Y+R*Coss[Ang1]);
     Ang2:=Ang1-DES;
    Ang1:=(Ang1+DES) mod 121;
    If Ang1 = 0 Then
     Ang1:=1;
    If Ang2 <= 0 Then
     Ang2:=120+Ang2;
{    Ang2:=Ang1-DES;
    Ang1:=(Ang1+DES) mod 120 + 1;
    If Ang2 < 0 Then
      Ang2:=120+Ang2;
    Ang2:=Abs(Ang2 mod 120 +1);
 }   m^.Ptgrafx[8]:=Round (m^.Ptgrafx[7]+RF*Seno[Ang1]);
    m^.Ptgrafy[8]:=Round (m^.Ptgrafy[7]+RF*Coss[Ang1]);
    m^.Ptgrafx[9]:=Round (m^.Ptgrafx[7]+RF*Seno[Ang2]);
    m^.Ptgrafy[9]:=Round (m^.Ptgrafy[7]+RF*Coss[Ang2]);
    m:=m^.prox;
  Until (m = nil);
End;


{*******************************************************************}
{* Calcula_Movimento recebe um ponteiro para o nodo cabeca da fila,*}
{* tem por funcao realizar todos os calculos do movimento, analizan*}
{* e decidindo com base na situacao corrente qual funcao devera ser*}
{ chamada, ou seja, em que situacao se encontra a esfera na guia   *}
{*******************************************************************}

Procedure Calcula_Movimento (Var cb: pt_cabecalho);

Var

  Ang: Integer;

Begin
  Movimento_Uniforme(cb);
  Looping_Total(cb);
  {Avalia node cb^.fim}
  If cb^.fim^.Teta <= Pi/2 then { Esta no primeito quadrante }
    Retorno(cb)
  else If cb^.fim^.Fcf <= 0.0 then { Vai cair em parabola }
    Begin
      Queda_Parabolica(cb);
      If cb^.fim^.Teta < (2*Pi) then { Caiu antes do fim do looping }
        If cb^.fim^.Teta < (Pi/2) then { Caiu no primeito quadrante }
          Retorno(cb)
        else { Caiu dentro do looping no terceiro ou quarto quadrante }
          Begin
            Looping_Total(cb);
            Movimento_Uniforme(cb)
          End
      else { Caiu no fim do looping }
        Movimento_Uniforme(cb);
    End
  else { Completou o looping sem perder o contato }
    Movimento_Uniforme(cb);
  Calculos_Graficos (cb);
End;

End.