Unit EntraDad;



{
                  Faz a inicializacao e finalizacao do
               programa. Controla a  interacao  com  o
               usuario no menu principal e  na  janela
               de entrada de dados.
}

Interface

Uses Crt, Dos, Graph, CalcMov, GerImg, RotGraf;

Const  {Mensagens das varias opcoes do menu principal e da entrada de dados}
     Mensagem   :  array[1..6] of String =
               (' Executa a Simulacao do Lancamento ',' Fornece Ajuda ',
               ' Principios da Fisica Utilizados',' Exemplo de Execucao',
               ' Finaliza programa',
               ' Entre com os Dados.');

Type
     Ptos  = array[1..3] of Boolean; {Vetor que indica se cada valor
     da entrada de dados contem ou nao um ponto}

Var
  Posi  : Byte; {Posicao do menu principal}
  Valor : array[1..3] of Str5; {valores da entrada de dados}

Procedure Inicializacao;

Procedure Escolhe_Menu(Var Posi:Byte);

Function Entra_Dados (Var fila: pt_cabecalho): Boolean;

Procedure Exibe_Dados_Entrados;

Procedure Fim_Tudo;

Implementation

Type Linha = String [50];

Const
    Col_Menu       :  array[1..5] of Integer =
               ( 10,77,132,214,273);  {coordenadas x das opcoes do menu}


Var

    MenuStr  :  array[1..5] of Pointer; { Ponteiros as imagens do
                            menu principal: Exec,Ajuda,Principios,Dados}
    TamMem   :  array[1..5] of Word; {Tamanho das imagens do menu principal}

 {********************************************************************
  * Exibe na parte superior esquerda os dados referentes ao movimento*
  * sendo executado.                                                 *
  ********************************************************************}

Procedure Exibe_Dados_Entrados;

Begin
  SetColor(COR_C);
  Rectangle(3,15,170,25);
  SetColor(COR_D);
  OutTextXY(6,23,Concat('R: ',Valor[1]));
  OutTextXY(58,23,Concat('V0: ',Valor[2]));
  OutTextXY(117,23,Concat('M: ',Valor[3]));
End;

 {********************************************************************
  * Recebe um ponteiro para o cabecalho da fila e possibilita o usua-*
  * rio entrar com os valores do raio, velocidade e massa. Retorna   *
  * True se os dados forem entrados e False se for abortado.         *
  ********************************************************************}

Function Entra_Dados (Var fila: pt_cabecalho): Boolean;

Const
    Lin_Entrada    :  array[1..3] of Integer =
               ( 25,35,45);           {coordenadas y do raio,vel.e massa}

Var Coord:Integer;
    I,
    Alt,Larg:Byte;      {Altura e largura em pixes do texto}
    M,V,R: Real;
    Nodo :pt_movimento; {Ponteiro ao nodo corrente}
    Pontos:Ptos;        {  Vetor indicando se ha ponto em cada
                         campo da entrada de dados}
    Linha : Frases;     {Vetor para as linhas exibidas nas mensagens}
    FundoEnt,
    JanAjuda: Pointer;
    Tam,
    TamJanAjuda: Word;
    Ch , Ch1  :Char;
    PosEnt     : Byte;  {Indice da posicao do campo da entrada de dados.}
    Xesq,
    Ysup,
    Xdir,
    Yinf       : Integer;
    EntStr        :  array[1..3] of Pointer;{Raio,Velocidade,Massa}
    TamEnt       :  array[1..3] of Word;

 {********************************************************************
  * Recebe um caracter pressionada na entrada de dados, o indice re- *
  * ferente a posicao que esta sendo entrado, a coluna do caracter   *
  * e um vetor indicando se existe ponto em cada um dos valores. In- *
  * terpreta o caracter recebido e, caso seja valido faz a movimenta-*
  * cao de campo ou a aceitacao do caracter como algarismo do valor  *
  * sendo entrado.                                                   *
  ********************************************************************}

  Procedure Escolhe_Entrada(Car:Char;Var PosEnt:Byte;Coord:Integer;
                                                        Var Pontos:Ptos);

  Var valido:Boolean; {Indica se o caracter entrado e valido}
      Aux   :Byte;
      Xesq1:Integer;
      ImCampo,ImCampoAnt:Pointer;
      Msg: Frases;    {Vetor de linhas de mensagens exibidas.}
      Num: Real;
      S : String; {Auxiliar para formar a mensagem da
                   ajuda na entrada de dados.}
      Ch: Char;

  Begin
     valido:=False;
     case Car of
       SETABAIXO,ENTER:Begin
            {prepara indice de um campo abaixo}
            Aux:=(PosEnt mod 3)+1;
            Ysup:=Lin_Entrada[Aux];
            ImCampo:=Entstr[Aux];
            Valido:=True;
           End;
       SETACIMA:Begin
            {prepara indice de um campo acima}
            If PosEnt = 1 Then Aux:=3 Else Aux:=PosEnt-1;
            Ysup:=Lin_Entrada[Aux];
            ImCampo:=Entstr[Aux];
            Valido:=True;
           End;
       '0'..'9':Begin
                if length(Valor[PosEnt])<5 then
                 Begin {nao esta cheio, acrescenta caracter}
                   Valor[PosEnt]:=Concat(Valor[PosEnt],Car);
                   SetColor(COR_A);
                   if (Car = '1')  then Coord:=Coord+1;
                   OutTextXY(Coord+30+TextWidth(Valor[PosEnt]),
                        Lin_Entrada[PosEnt]+TextHeight('0')-1,Car);
                                        {mostra novo valor}
                   SetColor(COR_B);
                 End;
                   End;
       '.':Begin
           if (length(Valor[PosEnt])<5) and not(Pontos[PosEnt]) then
            Begin {nao esta cheio e nao existe ponto naquele campo}
             Valor[PosEnt]:=Concat(Valor[PosEnt],Car);
             SetColor(COR_A);
             Coord:=Coord+1;
             OutTextXY(Coord+30+TextWidth(Valor[PosEnt]),
                       Lin_Entrada[PosEnt]+TextHeight('0')-1,Car);
                                {mostra novo valor}
             SetColor(COR_B);
             Pontos[PosEnt]:=True;
            End;
           End;
       'A','a':Begin
                 {prepara mensagens para exibicao}
                 FillChar (Msg, Sizeof (Msg),0);
                 new (Msg [1]);
                 new (Msg [2]);
                 new (Msg [3]);
                 Ch:= NULO;
                 {escolhe mensagem de acordo com o campo}
                 case PosEnt of
                  1:Begin
                     Num := AsctoReal(Valor[2]);
                     If (Num <> 0.0) and (Num < 251) then
                       Begin {valor do campo e valido}
                         Str(((Num*Num)/(5*9.81)):5:5,S);
                         Msg[1]^:='O valor ideal do raio para';
                         Msg[2]^:='esta velocidade e : ';
                         Msg[3]^:= Concat('    ',S);
                         Mensagem_Janela(50,63,225,97,Msg,Ch) {exibe mensagem}
                       End
                     else
                       Begin
                         Msg[1]^:='Valor da velocidade invalido.';
                         Msg[2]^:='Favor entrar com novo valor';
                         Msg[3]^:='Valor min .0001m/s e max 250m/s';
                         Mensagem_Janela(50,63,245,100,Msg,Ch); {exibe mensagem}
                       End
                    End;
                  2:Begin
                     Num := AsctoReal(Valor[1]);
                     If (Num <> 0.0) and (Num < 1001) then
                       Begin {o valor do campo e valido}
                         Str((Sqrt(5*Num*9.81)):5:5,S);
                         Msg[1]^:='O valor ideal da velocidade';
                         Msg[2]^:='para este raio e : ';
                         Msg[3]^:= Concat('     ',S);
                         Mensagem_Janela(50,63,235,100,Msg,Ch) {exibe mensagem}
                       End
                     else
                       Begin
                         Msg[1]^:='Valor do raio invalido.';
                         Msg[2]^:='Favor entrar com novo valor';
                         Msg[3]^:='Valor min .0001m e max 1000m';
                         Mensagem_Janela(50,63,235,100,Msg,Ch); {exibe mensagem}
                       End
                    End;
                  3:Begin
                     Num := AsctoReal(Valor[3]);
                     If (Num <> 0.0) and (Num < 50001) then
                       Begin {o valor do campo e valido}
                         Msg[1]^:='O valor da massa nao influi';
                         Msg[2]^:='no sucesso do movimento ';
                         Msg[3]^:='';
                         Mensagem_Janela(50,63,225,90,Msg,Ch) {exibe mensagem}
                       End
                     else
                       Begin
                         Msg[1]^:='Valor do campo invalido.';
                         Msg[2]^:='Favor entrar com novo valor';
                         Msg[3]^:='Valor min .0001Kg max 50000Kg';
                         Mensagem_Janela(50,63,235,100,Msg,Ch); {exibe mensagem}
                       End
                    End
                 End;
                 For Aux:=1 to 3 do
                    Dispose(Msg[Aux]); {Desaloca mensagem}
              End;
      BACKSPACE: Begin
            If (Copy(Valor[PosEnt],Length(Valor[PosEnt]),1)='.') Then
               Pontos[PosEnt]:=False; {sera apagado um ponto}
            SetColor(COR_D);
            {apaga o caracter}
            OutTextXY(Coord+36,Lin_Entrada[PosEnt]+TextHeight('0')-1,Valor[PosEnt]);
            Valor[PosEnt]:=Copy(Valor[PosEnt],1,Length(Valor[PosEnt])-1);
            SetColor(COR_A);
            OutTextXY(Coord+36,Lin_Entrada[PosEnt]+TextHeight('0')-1,Valor[PosEnt]);
                               {mostra novo valor}
          End;
      End;

      if valido then
                 Begin
                   {movimenta barra para novo campo}
                   ImCampoAnt:=Entstr[PosEnt];
                   PutImage(Coord,Lin_Entrada[PosEnt],ImCampoAnt^,Copyput);
                   PutImage(Coord,Ysup,ImCampo^,Notput);
                   Setcolor(COR_B);
                   OutTextXY(Coord+36,Lin_Entrada[PosEnt]+TextHeight('0')-1,Valor[PosEnt]);
                   PosEnt:=Aux;
                   SetColor(COR_A);
                   OutTextXY(Coord+36,Lin_Entrada[PosEnt]+TextHeight('0')-1,Valor[PosEnt]);
                 End;
  End; {Escolhe_Entrada}



Begin {Entra_Dados}
 Fillchar(Pontos,Sizeof(Pontos),0);{ Inicializa pontos com false}
 Repeat
    Coord:=20;
    {guarda a imagem anterior a da janela de entrada de dados}
    Tam := ImageSize(16,Coord,130,Coord+40);
    GetMem(Fundoent, Tam);
    GetImage(16,Coord,130,Coord+40,Fundoent^);
    SetFillStyle (EmptyFill, COR_A);
    Bar (16,Coord,130,Coord+40);
    {cria a janela de entrada de dados}
    SetColor(COR_C);
    Rectangle(16,Coord,130,Coord+40); {moldura da entrada de dados}
    OutTextXY(Coord+1,Lin_Entrada[1]+7,'Raio :      metros');
    OutTextXY(Coord+1,Lin_Entrada[2]+7,'V0   :      m/s');
    OutTextXY(Coord+1,Lin_Entrada[3]+7,'Massa:      kg');
    Apaga_Janela_Inferior;
    OutTextXY(2,197,Mensagem[6]);

    TamJanAjuda:=ImageSize (150,20,300,110);
    GetMem (JanAjuda, TamJanAjuda);
    GetImage (150,20,300,110,JanAjuda^);
    SetFillStyle(EmptyFill,COR_A);
    Bar(150,20,300,110);
    SetColor (COR_C);
    Rectangle (150,20,300,110);
    OutTextXY (155,30,'Pressione:');
    OutTextXY (155,40,' -Setas cima e baixo ou');
    OutTextXY (155,50,'  ENTER para movimentar');
    OutTextXY (155,60,'  a barra.');
    OutTextXY (155,70,' -Espaco para executar');
    OutTextXY (155,80,'  o movimento.');
    OutTextXY (155,90,' -"A" para ajuda.');
    OutTextXY (155,100,' -ESC para sair.');

  Larg:=6;
  Alt:=8;

   Xesq := Coord;
   Xdir := Coord+11*Larg;
   For I:=1 to 3 do
    Begin {Guarda as imagens das tres opcoes da entrada de dados}
     Ysup := Lin_Entrada[I];
     Yinf := Lin_Entrada[I]+Alt;
     TamEnt[I] := ImageSize(Xesq,Ysup,Xdir,Yinf);
     GetMem(Entstr[I], TamEnt[I]);
     GetImage(Xesq,Ysup,Xdir,Yinf,Entstr[I]^)
    End;

   {destaca a primeira opcao da entrada de dados}
   PutImage(Xesq,Lin_Entrada[1],Entstr[1]^,Notput);
   SetColor(COR_A);
   {coloca os valores dafault de raio vel. e massa}
   OutTextXY(Coord+36,Lin_Entrada[1]+7,Valor[1]);
   SetColor(COR_C);
   OutTextXY(Coord+36,Lin_Entrada[2]+7,Valor[2]);
   OutTextXY(Coord+36,Lin_Entrada[3]+7,Valor[3]);

  PosEnt:=1;
  repeat {recebe os valores de velocidade massa e raio}
      ch:=readkey;
      if ch<>ESPACO then Escolhe_Entrada(ch,PosEnt,Coord,Pontos);
  until (ch=ESPACO) or (ch=ESC);

  PutImage(16,Coord,Fundoent^,CopyPut);
  FreeMem (Fundoent, Tam);

  PutImage (150,20,JanAjuda^,CopyPut);
  FreeMem (JanAjuda, TamJanAjuda);

  If ch=ESPACO then
      Begin {nao foi abortado, preenche nodo cabecalho e inicial}
       Entra_Dados:=True;
       {converte os strings do raio velocidade e massa e poe seus valores
        no cabecalho da fila}
       R:=AsctoReal(Valor[1]);
       If R=0 Then
        Begin
         Fila^.R:=10;
         Valor[1]:='10' {Valor dafault}
        End
       Else Fila^.R:=R;
       V:=AsctoReal(Valor[2]);
       If V=0 Then
        Begin
         Fila^.V0:=25;
         Valor[2]:='25' {Valor default}
        End
       Else Fila^.V0:=V;
       M:=AsctoReal(Valor[3]);
       If M=0 Then
        Begin
         Fila^.M:=10;
         Valor[3]:='10' {valor default}
        End
       Else Fila^.M:=M;
       {Valores obtidos para a guia atraves de experiencia}
       If R<300 Then Fila^.Raio:=  40
        Else If R<600 Then Fila^.Raio:= 50
        Else Fila^.Raio:= 60;
       {coloca valores no cabecalho}
       Fila^.G := 9.81;
       Fila^.xc := MEIO;
       Fila^.yc := NIVELZERO - Fila^.raio;
       Nodo := Fila^.inicio;
       Nodo^.x := INICIO;
       Nodo^.y := NIVELZERO - ALTURA;
       {aloca as linhas de mensagem}
       FillChar(Linha,Sizeof(Linha),0);
       New(Linha[1]);
       New(Linha[2]);
       New(Linha[3]);
       If R>1000 Then
        Begin {Raio acima do limite}
          {prepara mensagem}
          Linha[1]^:=('Raio da guia excede os');
          Linha[2]^:=('limites estabelecidos,');
          Linha[3]^:=('Raio maximo = 1000 m');
          Mensagem_Janela(50,50,230,90,Linha,Ch1);
         End;

        If V>250 Then
         Begin {Velocidade acima do limite}
          Linha[1]^:=('Velocidade excede os limites');
          Linha[2]^:=('estabelecidos.');
          Linha[3]^:=('Velocidade maxima = 250 m/s ');
          Mensagem_Janela(50,50,230,90,Linha,Ch1);
         End;

        If M>50000 Then
         Begin {Massa acima do limite}
          Linha[1]^:=('Massa excede os limites');
          Linha[2]^:=('estabelecidos.');
          Linha[3]^:=('Massa maxima = 50000 Kg');
          Mensagem_Janela(50,50,230,90,Linha,Ch1);
         End;
        Dispose(Linha[1]);
        Dispose(Linha[2]);
        Dispose(Linha[3]);
      End
     Else
      Entra_Dados:=False;
 Until ((R<=1000) and (V<=250) and (M<=50000)) or (Ch=ESC);
 If Ch<>ESC Then {nao foi abortado}
    Cria_Guia(Fila^.Raio+10);
 For I:=1 to 3 do
  Freemem(Entstr[I],TamEnt[I]);
 { Desalocar o menu de entrada }
 Apaga_Janela_Inferior;
End; {Entra_Dados}

 {********************************************************************
  * Manipula a movimentacao da barra no menu principal e retorna o   *
  * indice da posicao que foi escolhida pelo usuario.                *
  * Recebe a posicao inicial da barra.                               *
  ********************************************************************}

Procedure Escolhe_Menu(Var Posi:Byte);

Var Ch:Char;

 {********************************************************************
  * Recebe o caracter pressionado no menu e a posicao corrente da    *
  * barra e, caso a tecla seja valida, movimenta a barra do menu     *
  * principal.                                                       *
  ********************************************************************}

 Procedure Escolhe(Lado:char;Var posi:Byte);

   Var valido:Boolean;   {Indica se o caracter pressionado e valido}
       Aux   :Byte;
       Xesq1:Integer;
       ImOpcao,ImOpcaoAnt:Pointer;
       Xesq,
       Ysup,
       Xdir,
       Yinf       : Integer;
   Begin

      valido:=true;
      case Lado of
      {muda coordenadas e indice para nova opcao}
     SETADIR,'6':Begin
             Aux:=(posi mod 5) +1;
             Xesq:=Col_Menu[Aux];
             ImOpcao:=Menustr[Aux];
            End;
     SETAESQ,'4':Begin
             if posi=1 then Aux:=5 else Aux:=posi-1;
             Xesq:=Col_Menu[Aux];
             ImOpcao:=Menustr[Aux];
            End;
      else valido:=false;
       End;
       if valido then {tecla pressionada valida}
                  Begin {movimenta barra para a nova opcao}
                    ImOpcaoAnt:=Menustr[posi];
                    Apaga_Janela_Inferior;
                    {Restaura imagem da opcao anterior}
                    PutImage(Col_Menu[posi],2,ImOpcaoAnt^,Copyput);
                    PutImage(Xesq,2,ImOpcao^,Notput);
                    OutTextXY(2,197,Mensagem[Aux]);
                    posi:=Aux;
                  End;
    End; {Escolhe}


Begin {Escolhe_Menu}
repeat
   Ch:=readkey;
   if (ch<>ENTER) and (ch<>ESPACO) then escolhe(ch,posi);
until (ch=ENTER)or (ch=ESPACO);
End;

 {********************************************************************
  * Escreve na janela superior as opcoes do menu principal, guarda   *
  * suas imagens e poe a barra na sua posicao inicial.               *
  ********************************************************************}

Procedure Menu_Principal;

Const Opcao : Array [1..5] of String =
      ('EXECUTA','AJUDA','PRINCIPIOS','EXEMPLO','FIM');

Var I:Byte;
    Xesq,
    Ysup,
    Xdir,
    Yinf       : Integer;
    Larg    : Byte;   {Largura em pixeis do texto}

    Arq: File;

Begin
  Assign (Arq, 'MNPRNC.IMG');
  Reset (Arq, 1);

  SetColor(COR_D);
  Larg:=6;
  Ysup := 2;
  Yinf := 10;
  For I:=1 to 5 do
   Begin {Escreve e guarda imagens das opcoes}
 {   OutTextXY(Col_Menu[I]+1,9,Opcao[I]); }
    Xesq:=Col_Menu[I];
    Xdir:=Col_Menu[I]+Length (Opcao[I])*Larg;
    TamMem[I] := ImageSize(Xesq,Ysup,Xdir,Yinf);
    GetMem(Menustr[I], TamMem[I]);

{    GetImage(Xesq,Ysup,Xdir,Yinf,Menustr[I]^); }

    BlockRead (Arq, Menustr[i]^, Tammem[i]);
   End;

  Close (Arq);

  {poe barra na primeira posicao}
{  OutTextXY(2,197,Mensagem[1]);
  PutImage(Col_Menu[1],Ysup,Menustr[1]^,Notput); }
End; {Menu_Principal}

 {********************************************************************
  * Desaloca as imagens do menu principal e retorna ao modo texto.   *
  ********************************************************************}

Procedure Fim_Tudo;

Var
  Cont:Integer;

Begin
 For Cont:=1 to 5 do
  FreeMem(Menustr[Cont],TamMem[Cont]);
 CloseGraph;
End;

 {********************************************************************
  * Inicializa o modo grafico nos padroes do programa e calcula a    *
  * tabela de senos e cossenos.                                      *
  ********************************************************************}

Procedure Inicializacao;

Type Vetor_tela1 = Array [0 .. 9] of Pointer;
     Vetor_tela2 = Array [0 .. 63] of Pointer;


Var

 Tela1: Vetor_tela1;
 Tela2: Vetor_tela2;
 Esf: Pointer;

Procedure InitGraphics;

Var
    GraphDriver,  { inicializacao }
    GraphMode,
    ErrorCode : Integer;


Begin
  CheckBreak := False; {Desativa verificacao de Control Break}
  GraphDriver := Detect;
  InitGraph(GraphDriver,GraphMode,'');
  ErrorCode := GraphResult;
  If ErrorCode < grOK
  then Begin
       CloseGraph;
       writeln(' Erro de sistema : ' + GraphErrorMsg(ErrorCode));
       halt(1);
       End;
  setgraphmode(CGAC0);
{  SetBkColor (1);}
End; {InitGraphics}

Procedure Movimenta_Esfera (H, V: Byte;Esf: Pointer);

Var

 I,X,Y: Word;


Begin
 Y:=V-9;
 X:=H;
 PutImage (X, Y, Esf^, XorPut);
 Delay (1000);
 PutImage (X, Y, Esf^, XorPut);
 While (X <= 145) do
  Begin
   PutImage (X, Y, Esf^, XorPut);
   Delay (10);
   PutImage (X, Y, Esf^, XorPut);
   Inc (x, 2)
  End;
 For I:= 1 to 120 do
  Begin
   X:=145+Round(41*Seno [I]*6/5);
   Y:=120+Round(41*Coss [I]);
   PutImage (X, Y, Esf^, XorPut);
   Delay (10);
   PutImage (X, Y, Esf^, XorPut)
  End;
 Y:=V-9;
 X:=145;
 While (X <= 290) do
  Begin
   PutImage (X, Y, Esf^, XorPut);
   Delay (10);
   PutImage (X, Y, Esf^, XorPut);
   Inc (x, 2)
  End;
 FreeMem (Esf, ImageSize (0,0,19,19))
End;


Function Le_Esfera: Pointer;

Var

 Tam: Word;
 Esf: Pointer;
 Arq: File;

Begin
 Assign (Arq, 'DSNESF.IMG');
 Reset (Arq,1);
 Tam:=ImageSize (0, 0, 20, 20);
 GetMem (Esf, Tam);
 BlockRead (Arq, Esf^, Tam);
 Close (Arq);
 Le_Esfera:=Esf
End;

Procedure Guarda_Seg_Tela (Var Tela2: Vetor_Tela2);

Var

 Tam,
 I: Word;
 Arq:File;

Begin

 Assign (Arq, 'SEGTL.IMG');
 Reset (Arq,1);
 Tam:=ImageSize (0, 0, 4, 199);
 For I:=0 to 63 do
  Begin
   GetMem (Tela2 [I], Tam);
   BlockRead (Arq, Tela2 [I]^, Tam);
  End;
 Close (Arq);
 ClearDevice;
End;

Procedure Anima_Seg_Tela (Tela2: Vetor_Tela2);

Const

 Col: Array [0..63] of Word =
  (135, 70, 190, 5, 255, 100, 55, 285, 180, 310, 80, 265, 220, 15, 165,
  0, 140, 235, 115, 280, 315, 30, 210, 85, 40, 60, 155, 25, 295, 170,
  90, 225, 65, 10, 150, 290, 240, 50, 245, 35, 300, 105, 215, 160, 95,
  125, 270, 75, 175, 260, 120, 305, 230, 110, 200, 20, 185, 250, 145,
  195, 275, 130, 205, 45);

Var

 Tam: Word;
 I: Byte;

Begin
 Tam:=ImageSize (0,0,4,199);
 For I:=0 to 63 do
  Begin
   PutImage (Col[I], 0, Tela2[Col[I] Div 5]^, CopyPut);
   FreeMem (Tela2 [Col[I] div 5], Tam);
   Sound (Col [I]);
  End;
 NoSound;
End;

Procedure Mensagem;

Var

 Ch:Char;

Begin
 SetTextStyle (smallfont,0,0);
 SetTextJustify (0,0);
 SetUserCharSize (1,1,1,1);
 SetColor (COR_C);
 SetFillStyle (EmptyFill, COR_C);
 Bar3D (21, 176 ,278, 190, 4, TopOn);
 SetColor (COR_B);
 Bar (25, 174, 270, 175);
 Bar (279, 177, 281, 186);
 SetColor (COR_C);
 OutTextXY (25, 185, 'Pressione qualquer tecla para prosseguir...');
 Ch:=ReadKey;
End;

Procedure DosComando (ComDos: Linha);

Begin
  SwapVectors;
  Exec (GetEnv ('COMSPEC'), '/C ' + ComDos);
  SwapVectors
End;

Begin {Inicializacao}
   InitGraphics;
   Esf:=Le_Esfera;
   Carrega_Tabela; {Calcula senos e cossenos}
   Posi:=1;
   Menu_Principal;
   Guarda_Seg_Tela (Tela2);
   DosComando ('PRMTL.COM');
   Movimenta_Esfera (25, 169, Esf);
   Mensagem;
   Anima_Seg_Tela (Tela2);
   Valor[1]:='10';{ Valores Default : Raio = 10 Metros         }
   Valor[2]:='25';{             Velocidade = 25 metros/segundo }
   Valor[3]:='10';{              Massa     = 10 Kilogramas     }
End;

End.