Unit GERIMG;

{
                  Faz o gerenciamento das imagens de todo o
              o movimento da esfera, incluindo os  graficos
              e a interacao com o usuario.
}


Interface

Uses Crt,Graph,CalcMov,RotGraf;

Procedure Gerencia_Imagem (Var cb: pt_cabecalho);

Implementation

 {********************************************************************
  *  Recebe as coordenadas do cando superior esquerdo do grafico na  *
  *  tela e o valor maximo da aceleracao.                            *
  *  Desenha o grafico da aceleracao.                                *
  ********************************************************************}

Procedure INIACEL (X1: Word; Y1: Word; VALSUPAC: Real);

 Var

  STRVAL: String [3];

 Begin
  SetColor(COR_B);
  Rectangle (X1,Y1+10,X1+67,Y1+70);       {Prim.Borda}
  Rectangle (X1+1,Y1+11,X1+66,Y1+69);   {Seg.Borda}
  Line (X1+40,Y1+13,X1+40,Y1+67);       {Linha Vertical esq}
  Line (X1+62,Y1+13,X1+62,Y1+67);       {Linha Vertical dir}
  Line (X1+40,Y1+13,X1+62,Y1+13);        {Traco hor.sup}
  Line (X1+40,Y1+67,X1+62,Y1+67);      {Traco vert.inf}
  Line (X1+40,Y1+26,X1+43,Y1+26);      {Traco hor.sup.med.esq}
  Line (X1+40,Y1+54,X1+43,Y1+54);      {Traco vert.inf.med.esq}
  Line (X1+59,Y1+26,X1+62,Y1+26);      {Traco hor.sup.med.dir}
  Line (X1+59,Y1+54,X1+62,Y1+54);      {Traco vert.inf.med.dir}
  Line (X1+40,Y1+40,X1+62,Y1+40);     {Traco mediano hor}
  Str (VALSUPAC:3:1,STRVAL);
  OutTextXY (X1+4,Y1+20,'+');
  OutTextXY (X1+14,Y1+20,STRVAL);
  OutTextXY (X1+10,Y1+43,'Nula');
  OutTextXY (X1+4,Y1+67,'-');
  OutTextXY (X1+14,Y1+67,STRVAL);
  Rectangle (X1,Y1,X1+67,Y1+11);       {Prim. borda}
  Rectangle (X1+1,Y1+1,X1+66,Y1+10);   {Seg. borda}
  OutTextXY (X1+4,Y1+9,'Aceleracao');
 End;

 {********************************************************************
  *  Recebe o deslocamento anterior e atual da barra de aceleracao   *
  *  assim como a direcao da barra anterior e atual.                 *
  *  Desenha o movimento da barra da aceleracao.                     *
  ********************************************************************}

 Procedure AtuAce (DesAnt, DesAtu: Integer; Dirant, Diratu: Boolean);

 Const

  X = 250;
  Y = 14;

 Begin
  If Diratu <> Dirant Then
   Begin
    {Apaga a barra anterior}
    SetFillStyle (EmptyFill,COR_A);
    Bar (X+45,Y+14,X+57,Y+64);
    {Desenha nova barra}
    SetFillStyle (SolidFill,COR_C);
    Bar (X+45,Y+40-Desatu,X+57,Y+40);
   End
  Else
  If  Diratu Then
   Begin {esta correta a direcao}
    If DesAnt > DesAtu Then
     Begin {diminuiu a aceleracao}
       {apaga pedaco da barra}
       SetFillStyle (EmptyFill,COR_A);
       Bar (X+45,Y+40-DesAnt,X+57,Y+40-DesAtu);
      End
     Else
      If DesAnt < DesAtu Then
      Begin  {aumentou a aceleracao}
        {desenha pedaco da barra}
        SetFillStyle (SolidFill,COR_C);
        Bar (X+45,Y+40-DesAtu,X+57,Y+40-DesAnt);
       End
   End
  Else
   Begin
    If DesAnt > DesAtu Then
     Begin {diminuiu a aceleracao}
       {apaga pedaco da barra}
       SetFillStyle (EmptyFill,COR_A);
       Bar (X+45,Y+40+DesAtu,X+57,Y+40+DesAnt);
    End
     Else
      If DesAnt < DesAtu Then
       Begin   {aumentou a aceleracao}
        {desenha pedaco da barra}
        SetFillStyle (SolidFill,COR_C);
        Bar (X+45,Y+40+DesAnt,X+57,Y+40+DesAtu);
       End
   End;
 End;

 {********************************************************************
  *  Recebe a coordenada do canto superior esquerdo do grafico na    *
  *  tela e o valor maximo da velocidade.                            *
  *  Desenha o grafico da velocidade.                                *
  ********************************************************************}

Procedure INIVEL (X1: Word; Y1: Word; VALSUPVEL: Real);

 Var

  STRVAL: String [3];

 Begin
  SetColor(COR_B);
  Rectangle (X1,Y1+10,X1+57,Y1+70);       {Prim.Borda}
  Rectangle (X1+1,Y1+11,X1+56,Y1+69);   {Seg.Borda}
  Line (X1+30,Y1+13,X1+30,Y1+67);       {Linha Vertical esq}
  Line (X1+52,Y1+13,X1+52,Y1+67);       {Linha Vertical dir}
  Line (X1+30,Y1+13,X1+52,Y1+13);        {Traco hor.sup}
  Line (X1+30,Y1+67,X1+52,Y1+67);      {Traco vert.inf}
  Line (X1+30,Y1+26,X1+33,Y1+26);      {Traco hor.sup.med.esq}
  Line (X1+30,Y1+54,X1+33,Y1+54);      {Traco vert.inf.med.esq}
  Line (X1+49,Y1+26,X1+52,Y1+26);      {Traco hor.sup.med.dir}
  Line (X1+49,Y1+54,X1+52,Y1+54);      {Traco vert.inf.med.dir}
  Line (X1+30,Y1+40,X1+33,Y1+40);      {Traco mediano hor.dir.}
  Line (X1+49,Y1+40,X1+52,Y1+40);      {Traco mediano hor.esq.}
  Rectangle (X1,Y1,X1+57,Y1+11);       {Prim. borda do titulo.}
  Rectangle (X1+1,Y1+1,X1+56,Y1+10);   {Seg. borda do titulo.}
  OutTextXY (X1+12,Y1+9,'Veloc.');
  Str (Round(VALSUPVEL),STRVAL);
  OutTextXY (X1+4,Y1+20,STRVAL);
  Str (Round(VALSUPVEL /2),STRVAL);
  OutTextXY (X1+4,Y1+43,STRVAL);
  OutTextXY (X1+4,Y1+67,'0');
 End;

 {********************************************************************
  *  Recebe o deslocamento anterior e atual da barra da velocidade.  *
  *  Desenha o movimento da barra de velocidade.                     *
  ********************************************************************}

 Procedure AtuVel (DesAnt, DesAtu: Word);

 Const

  X = 190;
  Y = 14;

 Begin
  If DesAnt > DesAtu Then
   Begin  {diminuiu a velocidade}
    {apaga pedaco da barra}
    SetFillStyle (EmptyFill,COR_A);
    Bar (X+34,Y+66-DesAnt,X+48,Y+66-DesAtu);
   End
  Else
   If DesAnt < DesAtu Then
    Begin {aumentou a velocidade}
     {desenha pedaco da barra}
     SetFillStyle (SolidFill,COR_C);
     Bar (X+34,Y+66-DesAtu,X+48,Y+66-DesAnt);
    End
 End;

 {********************************************************************
  *  Recebe a coordenada do canto sup. esq. do grafico das forcas.   *
  *  Desenha o grafico das forcas.                                   *
  ********************************************************************}

 Procedure INIVET (X1: Word; Y1: Word);

 Begin
  SetColor(COR_B);
  Rectangle (X1,Y1+10,X1+67,Y1+70);     {Prim.Borda}
  Rectangle (X1+1,Y1+11,X1+66,Y1+69);   {Seg.Borda}
  Rectangle (X1,Y1,X1+67,Y1+11);
  Rectangle (X1+1,Y1+1,X1+66,Y1+10);
  OutTextXY (X1+14,Y1+9,'Forcas');
 End;
 {********************************************************************
  *  Recebe os vetores com as coordenadas das forcas no nodo anterior*
  *  e atual.                                                        *
  *  Desenha o movimento dos vetores das forcas.                     *
  ********************************************************************}

 Procedure ATUVET (ptoantx, ptoanty, ptox, ptoy: Ptovet);

 Const

  X = 285;
  Y = 127;

 Begin
  {apaga os vetores anteriores}
  SetColor (COR_A);
  Line (X,Y,ptoantx[1],ptoanty[1]);                   {haste prim. vetor}
  Line (ptoantx[1],ptoanty[1],ptoantx[2],ptoanty[2]); {lado ponta prim. vetor}
  Line (ptoantx[1],ptoanty[1],ptoantx[3],ptoanty[3]); {lado ponta prim. vetor}
  Line (X,Y,ptoantx[4],ptoanty[4]);                   {haste seg. vetor}
  Line (ptoantx[4],ptoanty[4],ptoantx[5],ptoanty[5]); {lado ponta seg. vetor}
  Line (ptoantx[4],ptoanty[4],ptoantx[6],ptoanty[6]); {lado ponta seg. vetor}
  Line (X,Y,ptoantx[7],ptoanty[7]);                   {haste terc. vetor}
  Line (ptoantx[7],ptoanty[7],ptoantx[8],ptoanty[8]); {lado ponta terc. vetor}
  Line (ptoantx[7],ptoanty[7],ptoantx[9],ptoanty[9]); {lado ponta terc. vetor}
  {desenha os vetores atuais}
  SetColor (COR_C);
  Line (X,Y,ptox[1],ptoy[1]);                {haste prim. vetor}
  Line (ptox[1],ptoy[1],ptox[2],ptoy[2]);    {lado ponta prim. vetor}
  Line (ptox[1],ptoy[1],ptox[3],ptoy[3]);    {lado ponta prim. vetor}
  Line (X,Y,ptox[4],ptoy[4]);                {haste seg. vetor}
  Line (ptox[4],ptoy[4],ptox[5],ptoy[5]);    {lado ponta seg. vetor}
  Line (ptox[4],ptoy[4],ptox[6],ptoy[6]);    {lado ponta seg. vetor}
  Line (X,Y,ptox[7],ptoy[7]);                {haste terc. vetor}
  Line (ptox[7],ptoy[7],ptox[8],ptoy[8]);    {lado ponta terc. vetor}
  Line (ptox[7],ptoy[7],ptox[9],ptoy[9]);    {lado ponta terc. vetor}
 End;

 {********************************************************************
  *  Recebe um ponteiro para o nodo cabecalho.                       *
  *  Exibe na tela uma mensagem com os resultados do movimento.      *
  ********************************************************************}

Procedure Diagnostico_Movimento (Var fila: pt_cabecalho);

Var Msg: Frases;  {mensagem da janela}
    SN,
    Vel: String;
    Cont: Integer;
    Ch: Char;
    V: Real;

Begin
 V:=Sqrt(5*fila^.R*fila^.G);
 If fila^.V0 < V Then SN:='nao ' Else SN:=''; {vel. menor que a minima}
 Str(V:4:5,Vel);
 {prepara mensagem para a janela}
 FillChar(Msg,Sizeof(Msg),0);
 For Cont:=1 to 8 do
     New(Msg[Cont]);
 Msg[2]^:='';
 Msg[8]^:='';
 Msg[1]^:=' Diagnostico do Movimento ';
 Msg[3]^:=Concat(' A esfera ',SN,'conseguiu ');
 Msg[4]^:='realizar todo o "looping" ';
 Cont:=5;
 If fila^.V0 >= Sqrt(2*fila^.R*fila^.G) Then
  Begin {nao houve retorno}
   Msg[5]^:='em contato com a guia.';
   Cont:=6
  End;
 Msg[Cont]^:='A velocidade minima para obter';
 Msg[Cont+1]^:='sucesso com este raio seria :';
 Msg[Cont+2]^:=Concat('       ',Vel,' m/s');
 Mensagem_Janela(50,30,240,115,Msg,Ch); {exibe mensagem}
 For Cont:=1 to 8 do
     Dispose(Msg[Cont]);   {desaloca mensagem}
End;

 {********************************************************************
  *  Recebe um ponteiro para o nodo cabecalho da fila contendo o     *
  * movimento ja calculado. Controla toda a apresentacao da imagem   *
  * relativa ao movimento: colocacao da esfera, manipulacao dos gra- *
  * ficos e interacao com o usuario.                                 *
  ********************************************************************}

 Procedure Gerencia_Imagem (Var cb: pt_cabecalho);

 Var
   Im : pt_Im; {ponteiro para as imagens da esfera}
   ma,         {ponteiro ao nodo anterior}
   m: pt_movimento; {ponteiro ao nodo atual}
   Ch:Char;
   Cont : real;  {controla a posicao da esfera a ser mostrada}
   t : word;    {tamanho da imagem}
   I : byte;


 Procedure Coloca_Esfera (X,Y: Integer);

 Begin
  {escolhe a imagem da esfera a ser mostrada}
  PutImage (X,Y,Im[Trunc(Cont) mod 3]^,XorPut);
 End;

 Procedure Tira_Esfera (X,Y: Integer);

 Begin
  {escolhe a imagem da esfera a ser mostrada}
  PutImage (X,Y,Im[Trunc(Cont) mod 3]^,XorPut);
 End;


 Begin
 Cont := 0;
 {inicializa os graficos}
 IniVel (190,14,cb^.V0);
 IniAcel (250,14,cb^.Amax);
 IniVet (250,87);
 m:=cb^.inicio;
 ma:=cb^.inicio;
 Esfera(Im,t);
 Coloca_Esfera (m^.x, m^.y);
 Ch:=Pause (' Pressione algo para lancar a esfera.');
 Apaga_Janela_Inferior;
 OutTextXY(5,197,' Tecle ESPACO para pausa ou ESC para sair.');
 Ch:=NULO;
 Repeat
  {atualiza os graficos}
  AtuVel (ma^.vedes, m^.vedes);
  AtuAce (ma^.Acdes,m^.Acdes,ma^.Dir,m^.Dir);
  AtuVet (ma^.ptgrafx, ma^.ptgrafy, m^.ptgrafx, m^.ptgrafy);
  Delay (Round((1-(m^.V/cb^.V0))*7)); {espera inversamente proporcional a vel.}
  Tira_Esfera (ma^.x,ma^.y);
  ma:=m;
  m:=m^.prox;
  Cont := Cont + 0.5;
  Coloca_Esfera (ma^.x,ma^.y);
  If Keypressed Then Ch:=ReadKey;
  If Ch = ESPACO Then
  Begin
    Ch:=Pause('Pressione qualquer tecla para continuar');
    Ch:=NULO;
    OutTextXY(5,197,' Tecle ESPACO para pausa ou ESC para sair');
  End;
 Until (m=nil) or (Ch=ESC);
 Tira_Esfera (ma^.x,ma^.y);
 If Ch<>ESC Then Diagnostico_Movimento(cb); {nao foi abortado}
 SetFillStyle (EmptyFill,COR_A);
 Bar (250,14,317,84);       {Ap Ace}
 Bar (190,14,247,84);       {Ap Vel}
 Bar (250,87,317,157);      {Ap Vet}
 For I := 0 to 2 do
     FreeMem(Im[I],t); {desaloca esfera}
End;
end.
