Program Movimento_em_um_Circulo_Vertical;

{$M $700,0,60000}

Uses Crt, Graph, Dos, EntraDad, GerImg, CalcMov, RotGraf;

Var

 Fila: Pt_cabecalho;
 Acao,
 Cont: Byte;
 Dir : Boolean;
 Pdl : Procedure;

 {********************************************************************
  *  E chamada por interrupcao de software, faz o movimento do       *
  * pendulo do relogio durante o calculo do movimento.               *
  ********************************************************************}
 {$F+}

 Procedure Pendulo; interrupt;

 Begin
  If Acao = 7 Then
   Begin
    Acao:=0;
    SetColor(COR_A);
    Case Cont of
    1:
     Begin
      Circle (265,136,5);
      Line(265,131,270,123);
      SetColor (COR_C);
      Circle (270,140,5);
      Line(270,135,270,123);
      Cont:=2;
     End;
    2:
     Begin
      Circle (270,140,5);
      Line(270,135,270,123);
      SetColor (COR_C);
      If Dir = True
       Then
        Begin
         Circle (275,136,5);
         Line(275,131,270,123);
         Dir := False;
         Sound (2500);
         Delay (6);
         Nosound;
         Cont:=3;
        End
       Else
        Begin
         Circle (265,136,5);
         Line(265,131,270,123);
         Dir := True;
         Sound (1200);
         Delay (6);
         Nosound;
         Cont:=1;
        End
     End;
    3:
     Begin
      Circle (275,136,5);
      Line(275,131,270,123);
      SetColor (COR_C);
      Circle (270,140,5);
      Line(270,135,270,123);
      Cont:=2;
     End;
    End
   End
  Else
   Inc (Acao);
  InLine ($9C); {Termina e mantem residente}
  Pdl;
 End;

 {$F-}
 {********************************************************************
  * Faz movimento recebe um ponteiro para a cabeca da fila ja com    *
  * os dados requeridos p/ o movimento. Faz o calculo do movimento.  *
  ********************************************************************}

Procedure Faz_Movimento (Var fila: pt_cabecalho);

Const

     Relogio : array[1..6] of PointType =
     ((x: 250; y: 100),
      (x: 270; y:  85),
      (x: 290; y: 100),
      (x: 294; y:  97),
      (x: 275; y:  86),
      (x: 270; y:  85));
Var
   Alt,
   Dis    : Integer;
   RadAngHora,
   RadAngMin: Real;
   AngHora,
   AngMin,
   Hora,
   Min,
   Seg,
   MilSeg,
   Tam    : Word;
   Fundo  : Pointer;
   IntCont: Byte;
   Ch     : Char;

 {********************************************************************
  *  Mostra uma mensagem de espera durante o calculo do movimento.   *
  ********************************************************************}
Procedure Exibe_Mensagem;

Begin
  SetColor(COR_B);
  Bar3D(250,100,290,150,5,False);
  GetTime (Hora, Min, Seg, MilSeg);
  If Hora > 12 Then Hora:=Hora-12;
  AngHora:=30*Hora;
  RadAngHora:=AngHora*3.1416/180;
  AngMin:=6*Min;
  RadAngMin:=AngMin*3.1416/180;
  Alt:=-Round(Cos(RadAngHora)*5);
  Dis:=Round(Sin(RadAngHora)*4);
  Line (270,110,270+Dis,110+Alt);
  Alt:=-Round(Cos(RadAngMin)*7);
  Dis:=Round(Sin(RadAngMin)*8);
  Line (270,110,270+Dis,110+Alt);
  Rectangle(258,123,285,148);
  Rectangle(255,120,285,148);
  SetColor(COR_C);
  DrawPoly(SizeOf(Relogio) div SizeOf(PointType), Relogio); {desenha relogio}
  Circle(270,110,9);
  Tam := ImageSize(50,50,230,90);
  GetMem(Fundo, Tam);
  GetImage(50,50,230,90,Fundo^);
  SetViewPort(50,50,230,90,Clipon);
  ClearViewPort;
  Rectangle(0,0,180,40);
  SetColor(COR_D);
  OutTextXY(10,11,'Espere um instante enquanto ');
  OutTextXY(10,21,'sao realizados os calculos');
  OutTextXY(10,31,'referentes ao movimento...');
  SetViewPort(0,0,319,199,Clipon);
End;   {Exibe_Mensagem}

Procedure Retira_Mensagem;
{Retira a mensagem colocada por Exibe_Mensagem.}

Begin
  PutImage(50,50,Fundo^,CopyPut);
  FreeMem(Fundo,Tam);
  SetFillStyle(EmptyFill,COR_A);
  Bar(250,80,298,150);
End;

Begin   {Faz_Movimento}
   Exibe_Dados_Entrados;
   Avaliacao_Inicial (fila);
   Exibe_Mensagem;
   Acao:=0;
   Cont:=1;
   Dir:=True;
   {Prepara os vetores de interrupcao}
   GetIntVec ($1C,@Pdl);
   SetIntVec ($1C,@Pendulo);
   Calcula_Movimento (fila);
   SetIntVec ($1C,@Pdl); {Retorna os vetores ao normal}
   Retira_Mensagem;
   Repeat
    Gerencia_Imagem (fila);
    Apaga_Janela_Inferior;
    OutTextXY(7,197,' Pressione "R" para repetir ou algo para sair');
    Ch:=Upcase(ReadKey);
   Until Ch<>'R';
   Destroe_Fila (fila);
   SetFillStyle(EmptyFill,COR_A); { Apaga a janela que contem os dados entrados }
   Bar(3,15,170,25);  { pelo usuario }
End; {Faz_Movimento}

{********************************************************************
 *  Executa a simulacao do movimento, possibilitando a entrada de   *
 * dados pelo usuario. Recebe um ponteiro para o cabecalho da fila. *
 ********************************************************************}

Procedure Executa_Simulacao (Var fila: pt_cabecalho);

Begin
 Fila:=Inicializa_Fila(Fila);
 If Entra_Dados (fila) Then
   Faz_Movimento(fila);
End;


 {********************************************************************
  * Recebe o indice inicial e final das linhas do texto do arquivo   *
  * MCVHelp.DAT para ser exibido na tela, dividindo-o e manipulando-o*
  * em paginas.                                                      *
  ********************************************************************}

Procedure Ajuda (LININI, LINFIN: Word);
 Type

  ESTRUTHELP = Record
                Linha: Array [1..39] of Char;  {Linha do arquivo help}
                LF,          {Line Feed}
                CR: Byte;    {Control}
               End;

 Var

  Entrada: String [40];
  RegHelp: ESTRUTHELP;
  ArqHelp: File of ESTRUTHELP;

  LINHALIMISUP, {indices da linha do arquivo que sera editado}
  LINHALIMIINF,
  CONTADOR,
  NUMLINHA: Integer; {indice da linha editada}

  FUNDOHELP: Pointer;  {guarda a imagem anterior da tela}
  TAMANHO: Word; {tamanho da imagem}

  DECISAO: Char;

 Begin
  {abre o arquivo e prepara a tela.}
  Assign (ArqHelp,'MCVHELP.DAT');
  ReSet (ArqHelp);
  SetTextStyle (DefaultFont, 0, 0);
  SetUserCharSize (1,1,1,1);
  TAMANHO:=ImageSize (0,13,319,188);
  GetMem (FUNDOHELP, TAMANHO);
  GetImage (0,13,319,188,FUNDOHELP^);
  LINHALIMISUP:=LININI+11;
  LINHALIMIINF:=LININI;
  With RegHelp do
   Begin
    Repeat
     SetFillStyle (EmptyFill,COR_A);
     Rectangle (0,13,319,188);
     Rectangle (1,14,318,187);
     If LINHALIMISUP > LINFIN
      Then           {fim da parte inferior a ser editada}
       LINHALIMISUP:=LINFIN;
     If LINHALIMIINF < LININI
      Then           {fim da parte superior a ser editada}
       LINHALIMIINF:=LININI;
     If LINHALIMIINF+18 < LINFIN
      Then           {pode vir nova pagina}
       LINHALIMISUP:=LINHALIMIINF+18;
     NUMLINHA:=1;
     Bar(3,15,317,186);
     For CONTADOR:=LINHALIMIINF to LINHALIMISUP do
      Begin   {imprime nova tela}
       Seek (ArqHelp, CONTADOR-1);
       Read (ArqHelp, RegHelp);
       OutTextXY (4,8+(9*NUMLINHA),Linha);
       Inc (NUMLINHA);
      End;
     Repeat
      {repete ate que seja pressionada uma tecla valida}
      SetTextStyle(SmallFont,0,0);
      SetUserCharSize (1,1,1,1);
      DECISAO:=Pause('Use as setas para andar ou ESC para voltar');
      If DECISAO=#0 Then
        DECISAO:=ReadKey;
     Until ((DECISAO='2') or (DECISAO=SETABAIXO) or (DECISAO='8')
                          or (DECISAO=SETACIMA) or (DECISAO=ESC));
     SetTextStyle(DefaultFont,0,0);
     SetUserCharSize (1,1,1,1);
     If ((DECISAO = '2') or (DECISAO = SETABAIXO)) and (LINHALIMISUP < LINFIN)
      Then
       Begin
        Inc (LINHALIMIINF,19);
        Inc (LINHALIMISUP,19)
       End;
     If ((DECISAO = '8') or (DECISAO = SETACIMA)) and (LINHALIMIINF > LININI)
      Then
       Begin
        Dec (LINHALIMIINF,19);
        Dec (LINHALIMISUP,19)
       End;
    Until DECISAO = ESC;
   End;
  PutImage (0,13,FUNDOHELP^,NormalPut);
  Freemem (FUNDOHELP,TAMANHO);
  Close (ArqHelp);
  {Padrao de texto usado pelo programa}
  SetTextStyle (SmallFont, 0, 0);
  SetUserCharSize (1, 1, 1, 1);
 End;

 {********************************************************************
  *  Manuseia o texto do arquivo MCVHelp.DAT contendo os principios  *
  * da fisica utilizados.                                            *
  ********************************************************************}
Procedure Principios;

Begin
 Ajuda (1,273);
End;

Procedure Dados_Exemplo (Var Fila : pt_cabecalho);

Begin
   Cria_Guia (70);
   Valor[1]:='150';
   Valor[2]:='100';
   Valor[3]:='200';
   {Aloca e prepara o nodo inicial da fila}
   Fila:=Inicializa_Fila(Fila);
   Fila^.V0:=100.0;
   Fila^.R:=150.0;
   Fila^.M:=200.0;
   Fila^.raio:= 60;
   Fila^.G := 9.81 ;
   Fila^.xc := MEIO;
   Fila^.yc := NIVELZERO - Fila^.raio;
   Fila^.Inicio^.x := INICIO;
   Fila^.Inicio^.y := NIVELZERO - ALTURA;
End;


 {********************************************************************
  * Faz um exemplo do movimento usando dados pre-definidos.          *
  * Receber um ponteiro para o cabecalho da fila.                    *
  ********************************************************************}

Procedure Exemplo(Var fila:pt_cabecalho);

Var
  Msg:Frases;
  Cont:Byte;
  Ch:Char;

Begin
 {Preparacao da mensagem para a janela}
 FillChar(Msg,Sizeof(Msg),0);
 For Cont:=1 to 5 do
   New(Msg[Cont]);
  Msg[1]^:=' Esta opcao executa um exemplo do';
  Msg[2]^:='movimento com dados pre-definidos';
  Msg[3]^:='que sao: Velocidade=100 m/s';
  Msg[4]^:='         Raio=150 metros';
  Msg[5]^:='         Massa=200 Kilogramas';

  Mensagem_Janela(50,50,270,110,Msg,Ch); {Exibe a mensagem}
  For Cont:=1 to 5 do
    Dispose(Msg[Cont]); {Desaloca mensagem}
  If Ch<>ESC Then
  Begin
   Dados_Exemplo (fila);
   Faz_Movimento (fila);
  End;
End;


Begin        {Programa Principal}
   Inicializacao;
   Repeat
    Begin
     SetColor(COR_D);
     Apaga_Janela_Inferior;
     OutTextXY(2,197,Mensagem[posi]);
     Escolhe_Menu(posi);
     case posi of
        1: Executa_Simulacao (fila);
        2: Ajuda (274, 325);
        3: Principios;
        4: Exemplo(fila);
      End
    End
   Until posi=5;
  Fim_Tudo;
End.
