Unit RotGraf;

{
              Possui algumas funcoes graficas de interacao
           com o usuario, funcoes de desenho da  guia,  da
           esfera.
}


Interface

Uses Crt,Graph,CalcMov;

Const
   ESC = #27;
   ESPACO = #32;
   BACKSPACE = #8;
   ENTER = #13;
   SETACIMA = #72;
   SETABAIXO = #80;
   SETAESQ = #75;
   SETADIR = #77;
   NULO = #255;
   COR_A = 0;
   COR_B = 1;
   COR_C = 2;
   COR_D = 3;

Type Frases = array[1..20] of ^String; {Frases exibida por Mensagem_Janela}
     Str64  = String[64];
     Pt_Im  = array [0..2] of pointer; {Imagens da esfera}


Procedure Apaga_Janela_Inferior;

Function Pause(Strg:Str64):Char;

Procedure Mensagem_Janela(X1,Y1,X2,Y2:Word;Linhas:Frases;Var C:Char);

Procedure Cria_Guia(Raio:Integer);

Procedure Esfera(Var Esf : pt_im;Var t : word);

Implementation

 {********************************************************************
  * Apaga a janela de mensagens ao usuario.                          *
  ********************************************************************}

Procedure Apaga_Janela_Inferior;

Var c:Integer;

Begin
 c:=GetColor;
 SetFillStyle (EmptyFill, COR_A);
 Bar (2,190,317,198);
 SetColor (c)
End;

 {********************************************************************
  * Recebe uma linha a ser mostrada na janela inferior da tela e re- *
  * retorna o caracter pressionado pelo usuario.                     *
  ********************************************************************}

Function Pause(Strg:Str64):Char;

Var ch: char;

Begin
    Apaga_Janela_Inferior;
    OutTextXY(2,197,Strg);
    Pause := ReadKey;
    Apaga_Janela_Inferior;
End;

 {********************************************************************
  * Recebe quatro valores indicando as coordenadas do ponto superior *
  * esquerdo e inferior direito da janela; um vetor de apontadores p/*
  * string contendo as linhas que serao mostradas, linhas finais nao *
  * usadas devem vir com 'nil'; uma variavel char que retorna o ca-  *
  * racter pressionado pelo usuario. Abre uma janela nas coordenadas *
  * indicadas e exibe as linhas recebidas ate encontrar 'nil' ou ate *
  * terminar o vetor.                                                *
  ********************************************************************}

Procedure Mensagem_Janela(X1,Y1,X2,Y2:Word;Linhas:Frases;Var C:Char);

Var
   Cont,
   X,Y,
   Tam : Word; {Tamanho da imagem}
   Fundo: Pointer; {Ponteiro para a imagem}

Begin
  Tam := ImageSize(X1,Y1,X2,Y2);
  GetMem(Fundo, Tam);
  GetImage(X1,Y1,X2,Y2,Fundo^);
  SetViewPort(X1,Y1,X2,Y2,Clipon);
  ClearViewPort;
  SetColor(COR_C);
  Rectangle(0,0,X2-X1,Y2-Y1);
  SetColor(COR_D);
  Cont:=1;
  X:=10;
  Y:=10;
  While (Linhas[Cont]<>nil) and (Cont<=20) do
   Begin
    OutTextXY(X,Y,Linhas[Cont]^);
    Inc(Y,10);
    Inc(Cont);
   End;
  SetViewPort(0,0,319,199,Clipon);
  c:=Pause('Pressione qualquer tecla para continuar');
  PutImage(X1,Y1,Fundo^,CopyPut);
  FreeMem(Fundo,Tam);
End;

 {********************************************************************
  * Recebe o raio da guia e a desenha na tela.                       *
  ********************************************************************}

Procedure Cria_Guia(Raio:Integer);

Var u,v:Integer;
    poscirc:Integer;

Begin
 poscirc:=130;
 SetFillStyle(EmptyFill,COR_A);
 Bar(55,55,205,175);
 SetColor(COR_B);
u:=0;
Repeat
  Line(20-u,180-u,poscirc-u,180-u);
  Line(poscirc-u,179-u,poscirc*2-u,179-u);
  u:=u+2
Until u>=5;
 u:=20;
 For v:=1 to 5 do
    Line(u-v,189-v,u-v,181-v);
 Repeat
  u:=u+20;
  For v:=1 to 6 do
    Line(u-v,189-v,u-v,181);
 Until u>poscirc-20;
 Repeat
  u:=u+20;
  For v:=1 to 6 do
    Line(u-v,188-v,u-v,180);
 Until u>poscirc*2-40;
 u:=u+21;
  For v:=1 to 6 do
    Line(u-v,188-v,u-v,180);
 Line(u-1,178,u-4,175);

 { Desenha a Guia }
  If Raio = 50 Then Raio:=45;
  For u:=-1 to 1 do
    For v:=-1 to 1 do
     Begin
        Circle(poscirc+u-v,181+(Raio div 10)-Raio+u-v,Raio);
     End;
End;

 {********************************************************************
  * Recebe um vetor de ponteiros e um word, onde sao retornadas tres *
  * esferas e o tamanho da imagem, respectivamente.                  *
  ********************************************************************}

Procedure Esfera(Var Esf : pt_im;Var t : word);
 Begin
  {Desenha e guarda a primeira posicao da esfera}
  SetColor(COR_D);
  Circle(INICIO,NIVELZERO-10,7);
  Line(INICIO,NIVELZERO-10,INICIO,NIVELZERO-5);
  Line(INICIO,NIVELZERO-10,INICIO+5,NIVELZERO-13);
  Line(INICIO,NIVELZERO-10,INICIO-5,NIVELZERO-13);
  SetFillStyle(SolidFill,COR_B);
  FloodFill(INICIO,NIVELZERO-11,COR_D);
  SetFillStyle(SolidFill,COR_C);
  FloodFill(INICIO+1,NIVELZERO-10,COR_D);
  SetFillStyle(SolidFill,COR_D);
  FloodFill(INICIO-1,NIVELZERO-10,COR_D);
  t := ImageSize(INICIO-7,NIVELZERO-17,INICIO+7,NIVELZERO-3);
  GetMem(Esf[0],t);
  GetImage(INICIO-7,NIVELZERO-17,INICIO+7,NIVELZERO-3,Esf[0]^);
  SetFillStyle(EmptyFill,COR_A);
  Bar(INICIO-7,NIVELZERO-17,INICIO+7,NIVELZERO-3);

  {Desenha e guarda a segunda posicao da esfera}
  SetColor(COR_D);
  Circle(INICIO,NIVELZERO-10,7);
  Line(INICIO,NIVELZERO-10,INICIO,NIVELZERO-5);
  Line(INICIO,NIVELZERO-10,INICIO+5,NIVELZERO-13);
  Line(INICIO,NIVELZERO-10,INICIO-5,NIVELZERO-13);
  SetFillStyle(SolidFill,COR_D);
  FloodFill(INICIO,NIVELZERO-11,COR_D);
  SetFillStyle(SolidFill,COR_B);
  FloodFill(INICIO+1,NIVELZERO-10,COR_D);
  SetFillStyle(SolidFill,COR_C);
  FloodFill(INICIO-1,NIVELZERO-10,COR_D);
  GetMem(Esf[1],t);
  GetImage(INICIO-7,NIVELZERO-17,INICIO+7,NIVELZERO-3,Esf[1]^);
  SetFillStyle(EmptyFill,COR_A);
  Bar(INICIO-7,NIVELZERO-17,INICIO+7,NIVELZERO-3);

  {Desenha e guarda a terceira posicao da esfera}
  SetColor(COR_D);
  Circle(INICIO,NIVELZERO-10,7);
  Line(INICIO,NIVELZERO-10,INICIO,NIVELZERO-5);
  Line(INICIO,NIVELZERO-10,INICIO+5,NIVELZERO-13);
  Line(INICIO,NIVELZERO-10,INICIO-5,NIVELZERO-13);
  SetFillStyle(SolidFill,COR_C);
  FloodFill(INICIO,NIVELZERO-11,COR_D);
  SetFillStyle(SolidFill,COR_D);
  FloodFill(INICIO+1,NIVELZERO-10,COR_D);
  SetFillStyle(SolidFill,COR_B);
  FloodFill(INICIO-1,NIVELZERO-10,COR_D);
  GetMem(Esf[2],t);
  GetImage(INICIO-7,NIVELZERO-17,INICIO+7,NIVELZERO-3,Esf[2]^);
  SetFillStyle(EmptyFill,COR_A);
  Bar(INICIO-7,NIVELZERO-17,INICIO+7,NIVELZERO-3);
 end;


End.